﻿// Classic ASP에서 이미지 발송은 Ajax예제를 참조하세요
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;

using System.IO;
using System.Collections.Specialized;
namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        const string UserID = "";
        const string Key = "";
        public Form1()
        {
            InitializeComponent();
        }


        private void SendApiFileUpload(string file, string paramName, string contentType, NameValueCollection nvc, string FuncName)
        {
            string url = "https://apis.aligo.in/" + FuncName+"/";
            string boundary = "---------------------------" + DateTime.Now.Ticks.ToString("x");
            byte[] boundarybytes = System.Text.Encoding.ASCII.GetBytes("\r\n--" + boundary + "\r\n");

            HttpWebRequest wr = (HttpWebRequest)WebRequest.Create(url);
            wr.ContentType = "multipart/form-data; boundary=" + boundary;
            wr.Method = "POST";
            wr.KeepAlive = true;
            wr.Credentials = System.Net.CredentialCache.DefaultCredentials;
            Stream rs = wr.GetRequestStream();
            string formdataTemplate = "Content-Disposition: form-data; name=\"{0}\"\r\n\r\n{1}";
            string Params = "";
            foreach (string key in nvc.Keys)
            {
                rs.Write(boundarybytes, 0, boundarybytes.Length);
                string formitem = string.Format(formdataTemplate, key, nvc[key]);
                Params = Params + formitem.Replace("\r\n", "") + "\r\n";
                byte[] formitembytes = System.Text.Encoding.UTF8.GetBytes(formitem);
                rs.Write(formitembytes, 0, formitembytes.Length);
            }
            // LogHelper.WriteDebugLog("BackOffice HttpUploadFile(" + FuncName + ") Send :" + Params + "image file=" + file, Level.Info, null, typeof(CommonCommands));

            if (!file.Equals(string.Empty))
            {
                rs.Write(boundarybytes, 0, boundarybytes.Length);
                string headerTemplate = "Content-Disposition: form-data; name=\"{0}\"; filename=\"{1}\"\r\nContent-Type: {2}\r\n\r\n";
                string header = string.Format(headerTemplate, paramName, file, contentType);
                byte[] headerbytes = System.Text.Encoding.UTF8.GetBytes(header);
                rs.Write(headerbytes, 0, headerbytes.Length);
                FileStream fileStream = new FileStream(file, FileMode.Open, FileAccess.Read);
                byte[] buffer = new byte[4096];
                int bytesRead = 0;
                while ((bytesRead = fileStream.Read(buffer, 0, buffer.Length)) != 0)
                {
                    rs.Write(buffer, 0, bytesRead);
                }
                fileStream.Close();
                byte[] trailer = System.Text.Encoding.ASCII.GetBytes("\r\n--" + boundary + "--\r\n");
                rs.Write(trailer, 0, trailer.Length);
               
            }
            rs.Close();
            WebResponse wresp = null;
            
            try
            {
                wresp = wr.GetResponse();
                Stream stream2 = wresp.GetResponseStream();
                StreamReader reader2 = new StreamReader(stream2);
                string strResult = reader2.ReadToEnd();
                Console.WriteLine(strResult);
            }
            catch (Exception ex)
            {
                
                //System.Windows.MessageBox.Show("Error occurred while converting file", "Error!");
                if (wresp != null)
                {
                    wresp.Close();
                    wresp = null;
                }
                var w32ex = ex as Win32Exception;
                if (w32ex == null)
                {
                    w32ex = ex.InnerException as Win32Exception;
                }
                if (w32ex != null)
                {
                    int code = w32ex.ErrorCode;
                   
                    // do stuff
                }
            }
            finally
            {
                wr = null;
            }
        }

        private void BtnSend_Click(object sender, EventArgs e)
        {
            
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);
            nvc.Add("msg", "메세지 테스트 API TEST");
            nvc.Add("receiver", "01000000000");
            nvc.Add("destination", "01000000000|담당자");
            nvc.Add("sender", "020000000");
            nvc.Add("rdate", "");
            nvc.Add("rtime", "");
            nvc.Add("testmode_yn", "Y");
            nvc.Add("title", "TEST SMS SEND");

            SendApiFileUpload(@"C:\Users\darkjl\Pictures\test.png","image", "file", nvc,"send");
        }

        private void BtnSendmass_Click(object sender, EventArgs e)
        {
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);                       
            nvc.Add("sender", "020000000");
            nvc.Add("rdate", "");
            nvc.Add("rtime", "");
            nvc.Add("testmode_yn", "Y");

            //10개 전송 예제 숫자는 변경하고 싶은대로 변경 가능 
            for (int Cnt=0;Cnt < 10;Cnt++)
            {
                nvc.Add("rec_" + (Cnt + 1).ToString(), "수신번호(01000000000)");
                nvc.Add("msg_" + (Cnt + 1).ToString(), "(광고)알리고\n회원"+(Cnt+1).ToString()+"님 알리고를 추천드려요!!");
            }

            nvc.Add("msg_type", "MMS"); // SMS,LMS,MMS 원하는 타입 입력
            nvc.Add("cnt", "10"); //10개 전송 예제라서 10 숫자는 변경하고 싶은대로 변경 가능 

            SendApiFileUpload(@"C:\Users\darkjl\Pictures\test.png", "image", "file", nvc, "send_mass");
        }

        private void BtnList_Click(object sender, EventArgs e)
        {
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);            
            nvc.Add("page", "1");
            nvc.Add("page_size", "10");
            nvc.Add("start_date", "20190801");
            nvc.Add("limit_day", "30");
            SendApiFileUpload("", "image", "file", nvc, "list");
        }

        private void BtnsmsList_Click(object sender, EventArgs e)
        {
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);
            nvc.Add("mid", "");
            nvc.Add("page", "1");
            nvc.Add("page_size", "10");
            SendApiFileUpload("", "image", "file", nvc, "sms_list");
        }

        private void BtnCancel_Click(object sender, EventArgs e)
        {
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);
            nvc.Add("mid", "");   
            SendApiFileUpload("", "image", "file", nvc, "cancel");
        }

        private void Btnremain_Click(object sender, EventArgs e)
        {
            NameValueCollection nvc = new NameValueCollection();
            nvc.Add("user_id", UserID);
            nvc.Add("key", Key);
            SendApiFileUpload("", "image", "file", nvc, "remain");
        }
    }

}

